// Package imports:
import 'package:zego_express_engine/zego_express_engine.dart';

// Project imports:
import 'zego_uikit_user.dart';

class ZegoInRoomMessage {
  ZegoUIKitUser sender;
  String message;
  int sendTime; // Message send time, UNIX timestamp, in milliseconds.
  int messageID;
  ZegoIMSendBroadcastMessageResult result;

  ZegoInRoomMessage({
    required this.sender,
    required this.message,
    required this.sendTime,
    required this.messageID,
    required this.result,
  });

  ZegoInRoomMessage.fromBroadcastMessage(ZegoBroadcastMessageInfo message)
      : this(
          sender: ZegoUIKitUser.fromZego(message.fromUser),
          message: message.message,
          sendTime: message.sendTime,
          messageID: message.messageID,
          result: ZegoIMSendBroadcastMessageResult(0, message.messageID),
        );
}
